/**
 * Created by 393 on 2014/05/29.
 */
package
{
import controller.NewsLoaderControllerForAPI;
import controller.NewsLoaderControllerForRSS;

import flash.display.MovieClip;
import flash.events.TimerEvent;
import flash.utils.Timer;

import model.BasicData;
import model.NewsSourceData;
import model.SoundData;

import view_controller.Main2DViewController;
import view_controller.Main3DViewController;
import view_controller.UIViewController;

[SWF(backgroundColor="#000000", frameRate="30", width="350", height="240")]

public class MainContent extends MovieClip
{
    private var _main3DViewController:Main3DViewController;

    private var _main2DViewController:Main2DViewController;

    public function MainContent()
    {
        super();

        var newsSourceData:NewsSourceData = new NewsSourceData();
        var soundSequenceData:SoundData = new SoundData();

        if(BasicData.isNewsAPI)
        {
            var newsLoaderControllerForAPI:NewsLoaderControllerForAPI = new NewsLoaderControllerForAPI(newsSourceData);
            newsLoaderControllerForAPI.getTopicData();
        }
        else
        {
            var newsLoaderController:NewsLoaderControllerForRSS = new NewsLoaderControllerForRSS(newsSourceData);
            newsLoaderController.getTopicData();
        }


        _main3DViewController = new Main3DViewController(newsSourceData, soundSequenceData);
        addChild(_main3DViewController.view);

        _main2DViewController = new Main2DViewController(newsSourceData, soundSequenceData);
        addChild(_main2DViewController.view);

        var startDelay:Timer = new Timer(2000, 1);
        startDelay.addEventListener(TimerEvent.TIMER, startDelayTimerHandler);
        startDelay.start();

        //FOR DEBUG
        if(stage == null)
        {
            var uiViewController:UIViewController = new UIViewController(newsSourceData, soundSequenceData, _main3DViewController);
            addChild(uiViewController.view);
        }
    }

    private function startDelayTimerHandler(event:TimerEvent):void
    {
        _main3DViewController.renderReady();
        _main2DViewController.renderReady();
    }
}

}
