/**
 * Created by sakusan on 2014/05/24.
 */
package controller
{
import flash.events.Event;
import flash.events.EventDispatcher;
import flash.events.IEventDispatcher;
import flash.events.IOErrorEvent;
import flash.events.SecurityErrorEvent;
import flash.net.URLLoader;
import flash.net.URLRequest;
import flash.net.URLRequestMethod;
import flash.net.URLVariables;
import flash.system.Security;

import model.BasicData;

public class APIController extends EventDispatcher
{
    private var _urlRequest:URLRequest;

    private var _urlVariables:URLVariables;

    private var _urlLoader:URLLoader;

    public function APIController(target:IEventDispatcher = null)
    {
        super(target);

        Security.loadPolicyFile(BasicData.POLICY_FILE);

        _urlVariables = new URLVariables();
        _urlLoader = new URLLoader();
        _urlLoader.addEventListener(Event.COMPLETE, loadCompleteHandler);
        _urlLoader.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
        _urlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
        _urlRequest = new URLRequest();
        _urlRequest.method = URLRequestMethod.GET;
    }

    private function loadCompleteHandler(event:Event):void
    {
        dispatchEvent(new APIControllerEvent(APIControllerEvent.LOAD_COMPLETE, event.target.data))
    }

    private function ioErrorHandler(event:IOErrorEvent):void
    {
        dispatchEvent(new APIControllerEvent(APIControllerEvent.IO_ERROR));
    }
    private function securityErrorHandler(event:SecurityErrorEvent):void
    {
        dispatchEvent(new APIControllerEvent(APIControllerEvent.SECURYTY_ERROR));
    }

    public function getData(apiPath:String):void
    {
        _urlRequest.url = apiPath;
        _urlLoader.load(_urlRequest);
    }
    public function getDataAPI(apiPath:String,data:URLVariables):void
    {
        _urlRequest.data = data;
        _urlRequest.url = apiPath;
        _urlLoader.load(_urlRequest);
    }

}
}
