/**
 * Created by 393 on 2014/05/29.
 */
package controller
{
import flash.events.EventDispatcher;
import flash.net.URLVariables;

import model.BasicData;
import model.NewsData;
import model.NewsSourceData;

import util.StaticFunc;

public class NewsLoaderControllerForAPI extends EventDispatcher
{
    private var _apiController:APIController;
    private var _newsSourceData:NewsSourceData;

    public function NewsLoaderControllerForAPI(newsSourceData:NewsSourceData)
    {
        super();
        _newsSourceData = newsSourceData;

        _apiController = new APIController();
    }

    public function getTopicData(startIndex:int = 1):void
    {
        _apiController.addEventListener(APIControllerEvent.LOAD_COMPLETE, topicData_loadCompleteHandler);
        _apiController.addEventListener(APIControllerEvent.IO_ERROR, ioErrorHandler);

        const APP_ID:String = "あなたのアプリケーションIDを入れてください";
        //※↓のNEWS TOPIC APIは6/30で終了しているので使えません
        const NEWS_API_PATH:String = "http://news.yahooapis.jp/NewsWebService/V2/topics";
        const PICKUP_CATEGORY:String = "all";

        var urlVariables:URLVariables = new URLVariables();
        urlVariables.appid = APP_ID;
        urlVariables.pickupcategory = PICKUP_CATEGORY;
        urlVariables.start = 1;
        urlVariables.query = BasicData.KEYWORD_LIST.toString();

        _apiController.getDataAPI(NEWS_API_PATH, urlVariables);
    }

    private function topicData_loadCompleteHandler(event:APIControllerEvent):void
    {
        _apiController.removeEventListener(APIControllerEvent.LOAD_COMPLETE, topicData_loadCompleteHandler);
        _apiController.removeEventListener(APIControllerEvent.IO_ERROR, ioErrorHandler);
        var xml:XML = new XML(event.data);
        const APP_NAME_SPACE:String = "urn:yahoo:jp:news";
        default xml namespace = new Namespace(APP_NAME_SPACE);

        //初期化
        var _totalResultAvailableLength:int = Math.ceil(xml.@totalResultsAvailable / 10);
        //検索結果が0じゃなかったら
        var array:Vector.<NewsData> = new Vector.<NewsData>();
        if (_totalResultAvailableLength > 0)
        {
            for (var i:int = 0, l:int = xml.Result.length(); i < l; i++)
            {
                var title:String = xml.Result[i].Title;
                var pickupCategory:String = xml.Result[i].PickupCategory;
                if (title && title != "")
                {
                    var newsData:NewsData = new NewsData(title, pickupCategory);
                    array.push(newsData);
                }
            }
        }
        StaticFunc.shuffleArray(array);
        _newsSourceData.loadNewsList = array;
    }

    private function ioErrorHandler(e:APIControllerEvent):void
    {
        _apiController.removeEventListener(APIControllerEvent.LOAD_COMPLETE, topicData_loadCompleteHandler);
        _apiController.removeEventListener(APIControllerEvent.IO_ERROR, ioErrorHandler);
        _newsSourceData.setErrorData();
    }
}
}
