/**
 * Created by 393 on 2014/05/29.
 */
package controller
{
import flash.events.EventDispatcher;
import flash.net.URLVariables;
import flash.utils.Dictionary;

import model.BasicData;
import model.NewsData;
import model.NewsSourceData;

import util.StaticFunc;

public class NewsLoaderControllerForRSS extends EventDispatcher
{
    private var _apiController:APIController;
    private var _newsSourceData:NewsSourceData;
    private var _categoryName:Dictionary = new Dictionary();

    public function NewsLoaderControllerForRSS(newsSourceData:NewsSourceData)
    {
        super();
        _newsSourceData = newsSourceData;
        setCategoryInit();

        _apiController = new APIController();
    }

    private function setCategoryInit():void
    {
        _categoryName["entertainment"] = BasicData.CATEGORY_ENTERTAINMENT;
        _categoryName["sports"] = BasicData.CATEGORY_SPORTS;
        _categoryName["computer"] = BasicData.CATEGORY_COMPUTER;
        _categoryName["science"] = BasicData.CATEGORY_SCIENCE;
        _categoryName["economy"] = BasicData.CATEGORY_ECONOMIC;
        _categoryName["domestic"] = BasicData.CATEGORY_DOMESTIC;
        _categoryName["world"] = BasicData.CATEGORY_WORLD;
        _categoryName["local"] = BasicData.CATEGORY_LOCAL;
    }

    public function getTopicData():void
    {
        _apiController.addEventListener(APIControllerEvent.LOAD_COMPLETE, topicData_loadCompleteHandler);
        _apiController.addEventListener(APIControllerEvent.IO_ERROR, errorHandler);
        _apiController.addEventListener(APIControllerEvent.SECURYTY_ERROR, errorHandler);

        _apiController.getData(BasicData.NEWS_API_PATH);
    }

    private function topicData_loadCompleteHandler(event:APIControllerEvent):void
    {
        _apiController.removeEventListener(APIControllerEvent.LOAD_COMPLETE, topicData_loadCompleteHandler);
        _apiController.removeEventListener(APIControllerEvent.IO_ERROR, errorHandler);
        _apiController.removeEventListener(APIControllerEvent.SECURYTY_ERROR, errorHandler);
        var xml:XML = new XML(event.data);

        var _totalResultAvailableLength:int = xml.channel[0].item.length();
        var array:Vector.<NewsData> = new Vector.<NewsData>();
        var pickupCategory:String;
        if (_totalResultAvailableLength > 0)
        {
            for (var i:int = 0, l:int = _totalResultAvailableLength; i < l; i++)
            {
                var title:String = xml.channel[0].item[i].title;
                pickupCategory = getCategoryWord(xml.channel[0].item[i].link);
//                if(BasicData.isDebug) pickupCategory = BasicData.CATEGORY_NAME_ARRAY[i];

                if (title && title != "")
                {
                    var newsData:NewsData = new NewsData(title, pickupCategory);
                    array.push(newsData);
                }
            }
        }
        StaticFunc.shuffleArray(array);
        _newsSourceData.loadNewsList = array;
    }




    private function getCategoryWord(str:String):String
    {
        var enWord:String = str.split("/")[4];
        return _categoryName[enWord]
    }

    private function errorHandler(e:APIControllerEvent):void
    {
        _apiController.removeEventListener(APIControllerEvent.LOAD_COMPLETE, topicData_loadCompleteHandler);
        _apiController.removeEventListener(APIControllerEvent.IO_ERROR, errorHandler);
        _apiController.removeEventListener(APIControllerEvent.SECURYTY_ERROR, errorHandler);

        _newsSourceData.setErrorData();
    }
}
}
