/**
 * Created by 393 on 2014/06/02.
 */
package model
{
import away3d.materials.TextureMaterial;
import away3d.textures.BitmapTexture;

import flash.display.BitmapData;
import flash.utils.Dictionary;

public class CategoryData
{
    private static const CATEGORY_DATA_BY_RECEIVED_NAME:Dictionary = new Dictionary();

    public static const CATEGORY_0:CategoryData = new CategoryData(
            BasicData.CATEGORY_ENTERTAINMENT, 0xFF6600, "C", 120,"migi.percus2"
    );
    public static const CATEGORY_4:CategoryData = new CategoryData(
            BasicData.CATEGORY_SPORTS, 0x3399FF, "G", 120,"konami"
    );

    public static const CATEGORY_5:CategoryData = new CategoryData(
            BasicData.CATEGORY_COMPUTER, 0xCC66FF, "D", 130,"valsound.bell16"
    );
    public static const CATEGORY_6:CategoryData = new CategoryData(
            BasicData.CATEGORY_SCIENCE, 0x99CCFF, "E", 130,"valsound.lead19"
    );
    public static const CATEGORY_3:CategoryData = new CategoryData(
            BasicData.CATEGORY_ECONOMIC, 0xFF2222, "D", 130,"valsound.bass4"
    );

    public static const CATEGORY_1:CategoryData = new CategoryData(
            BasicData.CATEGORY_DOMESTIC, 0x00CC99, "A", 110,"valsound.lead10"
    );
    public static const CATEGORY_2:CategoryData = new CategoryData(
            BasicData.CATEGORY_WORLD, 0x66FFCC, "D", 110,"valsound.brass13"
    );
    public static const CATEGORY_7:CategoryData = new CategoryData(
            BasicData.CATEGORY_LOCAL, 0x946e4b, "A", 110,"valsound.bell16"
    );
    public static const CATEGORY_TITLE:CategoryData = new CategoryData(
            BasicData.CATEGORY_TITLE, 0xCC5500, "A", 150,"konami"
    );

    public static const CATEGORY_INFO:CategoryData = new CategoryData(
            BasicData.CATEGORY_INFO, 0x999999, "A", 120,"valsound.world5"
    );


    private static function register(categoryData:CategoryData):void
    {
        var name:String = categoryData.name;
        CATEGORY_DATA_BY_RECEIVED_NAME[name] = categoryData;
    }

    private var _name:String;
    private var _themeColor:int;
    private var _soundKey:String;
    private var _bpm:int;
    private var _index:int;
    private var _material:TextureMaterial;
    private var _voice:String;

    public function CategoryData(name:String, themeColor:int, soundKey:String, bpm:int,voice:String)
    {
        _name = name;
        _themeColor = themeColor;
        _soundKey = soundKey;
        _index = index;
        _bpm = bpm;
        _voice = voice;
        var bmd:BitmapData = new BitmapData(16, 16, false, _themeColor);
        _material = new TextureMaterial(new BitmapTexture(bmd));
        register(this);
    }

    public static function getCategoryDataByName(name:String):CategoryData
    {
        if(CATEGORY_DATA_BY_RECEIVED_NAME[name]) return CATEGORY_DATA_BY_RECEIVED_NAME[name];
        else return CATEGORY_DATA_BY_RECEIVED_NAME[BasicData.CATEGORY_ENTERTAINMENT];
    }

    public function get name():String
    {
        return _name;
    }

    public function get themeColor():int
    {
        return _themeColor;
    }

    public function get soundKey():String
    {
        return _soundKey;
    }

    public function get bpm():int
    {
        return _bpm;
    }

    public function get index():int
    {
        return _index;
    }

    public function get voice():String
    {
        return _voice;
    }
}
}
