/**
 * Created by 393 on 2014/06/02.
 */
package model
{

import away3d.materials.TextureMaterial;
import away3d.materials.lightpickers.StaticLightPicker;
import away3d.textures.BitmapTexture;

import flash.display.BitmapData;
import flash.utils.Dictionary;

public class MaterialData
{
    private static const MATERIAL_DATA_BY_RECEIVED_THEME_COLOR:Dictionary = new Dictionary();

    public static const MATERIAL_0:MaterialData = new MaterialData(
            CategoryData.CATEGORY_0.themeColor
    );
    public static const MATERIAL_1:MaterialData = new MaterialData(
            CategoryData.CATEGORY_1.themeColor
    );
    public static const MATERIAL_2:MaterialData = new MaterialData(
            CategoryData.CATEGORY_2.themeColor
    );
    public static const MATERIAL_3:MaterialData = new MaterialData(
            CategoryData.CATEGORY_3.themeColor
    );
    public static const MATERIAL_4:MaterialData = new MaterialData(
            CategoryData.CATEGORY_4.themeColor
    );
    public static const MATERIAL_5:MaterialData = new MaterialData(
            CategoryData.CATEGORY_5.themeColor
    );
    public static const MATERIAL_6:MaterialData = new MaterialData(
            CategoryData.CATEGORY_6.themeColor
    );
    public static const MATERIAL_7:MaterialData = new MaterialData(
            CategoryData.CATEGORY_7.themeColor
    );
    public static const MATERIAL_TITLE:MaterialData = new MaterialData(
            CategoryData.CATEGORY_TITLE.themeColor
    );
    public static const MATERIAL_INFO:MaterialData = new MaterialData(
            CategoryData.CATEGORY_INFO.themeColor
    );

    public static const MATERIAL_BLACK:MaterialData = new MaterialData(
            0x252525
    );
    public static const MATERIAL_YELLOW:MaterialData = new MaterialData(
            0xFFFF22
    );
    public static const MATERIAL_GRAY:MaterialData = new MaterialData(
            0xFFFFFF
    );

    private static function register(materialData:MaterialData):void
    {
        MATERIAL_DATA_BY_RECEIVED_THEME_COLOR[materialData.themeColor] = materialData;
    }

    public static const ALL:Array = [
        MATERIAL_0
        , MATERIAL_1
        , MATERIAL_2
        , MATERIAL_3
        , MATERIAL_4
        , MATERIAL_5
        , MATERIAL_6
        , MATERIAL_7
        , MATERIAL_TITLE
        , MATERIAL_INFO
        , MATERIAL_BLACK
        , MATERIAL_GRAY
        , MATERIAL_YELLOW
    ];
    private var _themeColor:int;
    private var _material:TextureMaterial;


    public function MaterialData(themeColor:int)
    {
        _themeColor = themeColor;
        var bmd:BitmapData = new BitmapData(16, 16, false, themeColor);
        _material = new TextureMaterial(new BitmapTexture(bmd));
        register(this);
    }

    public static function init(staticLightPicker:StaticLightPicker):void
    {
        for (var i:int = 0, l:int = ALL.length; i < l; i++)
        {
            ALL[i].material.lightPicker = staticLightPicker;
            ALL[i].material.specular = 0.3;
        }
    }

    public static function getMaterialDataByThemeColor(themeColor:int):MaterialData
    {
        if(MATERIAL_DATA_BY_RECEIVED_THEME_COLOR[themeColor]) return MATERIAL_DATA_BY_RECEIVED_THEME_COLOR[themeColor];
        else return MATERIAL_DATA_BY_RECEIVED_THEME_COLOR[0xFF6600];
    }


    public function get themeColor():int
    {
        return _themeColor;
    }

    public function get material():TextureMaterial
    {
        return _material;
    }
}
}
