/**
 * Created by 393 on 2014/05/29.
 */
package model
{
import flash.display.BitmapData;
import flash.events.Event;
import flash.events.EventDispatcher;
import flash.geom.Matrix;

import util.StaticFunc;

public class NewsSourceData extends EventDispatcher
{
    public static const LOAD_NEWS_LIST_UPDATE:String = "loadNewsListUpdate";
    public static const SET_SOURCE_NEWS_LIST:String = "setLoadData2SourceNewsList";
    public static const SET_CURRENT_TEXT:String = "setCurrentText";

    private var _bdW:int = BasicData.TEXT_DISPLAY_WIDTH;
    private var _bdH:int = BasicData.TEXT_DISPLAY_HEIGHT;

    private var _loadNewsList:Vector.<NewsData> = new Vector.<NewsData>();
    private var _sourceNewsList:Vector.<NewsData> = new Vector.<NewsData>();
    private var _titleNewsList:Vector.<NewsData> = new Vector.<NewsData>();
    private var _infoNewsList:Vector.<NewsData> = new Vector.<NewsData>();
    private var _errorNewsList:Vector.<NewsData> = new Vector.<NewsData>();
    private var _currentIndex:int = 0;
    private var _textFieldData:TextFieldData;
    private var _currentNewsData:NewsData;
    private var _currentNewsText:String;
    private var _sourceTextFieldBitmapData:BitmapData;
    private var _textFieldWidthCount:int = 0;
    private var _currentNewsColor:int;

    private var _isTitleTextFinished:Boolean = false;
    private var _isDataLoadError:Boolean;

    private var _setTextCount:int = 0;

    public function NewsSourceData()
    {
        super();

        initInfoData();
    }
    public function initInfoData():void
    {
        var infoData:NewsData = new NewsData(BasicData.INSERT_INFO_MESSAGE.text, BasicData.INSERT_INFO_MESSAGE.category);
        _infoNewsList[0] = infoData;
    }

    public function setErrorData():void
    {
        for(var i:int = 0, l:int = BasicData.ERROR_MESSAGE.length; i < l; i++)
        {
            _errorNewsList[i] = new NewsData(BasicData.ERROR_MESSAGE[i].text,BasicData.ERROR_MESSAGE[i].category);
        }
        _isDataLoadError = true;
        this.loadNewsList = _errorNewsList;
    }

    public function setTitleData():void
    {
        var date:Date = new Date();
        var month:int = date.getMonth() + 1;
        var day:int = date.getDate();

        var dafaultData:NewsData = new NewsData(month+"/"+day + "の最新NEWS", "タイトル");
        _titleNewsList[0] = dafaultData;
        _textFieldData = new TextFieldData(this);
        this.sourceNewsList = _titleNewsList;
    }

    public function set loadNewsList(value:Vector.<NewsData>):void
    {
        _loadNewsList = value;
        dispatchEvent(new Event(NewsSourceData.LOAD_NEWS_LIST_UPDATE));
    }

    public function setLoadData2SourceNewsList():void
    {
        if (_loadNewsList.length > 0)
        {
            _isTitleTextFinished = true;
            this.sourceNewsList = _loadNewsList;
        }
        else
        {
            //this.currentNewsText = "データ無し"
        }
        dispatchEvent(new Event(NewsSourceData.SET_SOURCE_NEWS_LIST));
    }

    public function set currentNewsText(value:String):void
    {
        _currentNewsText = value;
        changeTextField();
    }
    public function setBitmapData():void
    {
        if (!_sourceTextFieldBitmapData)
        {
            return;
        }
        _textFieldWidthCount = 0;
        _sourceTextFieldBitmapData.draw(_textFieldData);
    }

    public function updateBitmapData():void
    {
        if (!_sourceTextFieldBitmapData)
        {
            return;
        }
        _sourceTextFieldBitmapData.draw(_textFieldData, new Matrix(1, 0, 0, 1, _textFieldWidthCount, 0), null, null);
        _textFieldWidthCount--;
    }

    public function checkActiveSound(i:int):int
    {
        var index:int = -1;
        if (!_sourceTextFieldBitmapData)
        {
            return index;
        }
        else
        {
            return _sourceTextFieldBitmapData.getPixel(BasicData.SOUND_ON_POSITION_X_LIST[i], i)
        }
    }


    public function get sourceTextFieldBitmapData():BitmapData
    {
        return _sourceTextFieldBitmapData;
    }

    public function get textFieldWidthCount():int
    {
        return _textFieldWidthCount;
    }

    public function set sourceNewsList(list:Vector.<NewsData>):void
    {
        _sourceNewsList = null;
        _sourceNewsList = list;

        this.currentIndex = 0;
    }

    private function setCurrentText():void
    {
        if (_sourceNewsList.length > 0)
        {
            _currentNewsData = _sourceNewsList[_currentIndex];
            this.currentNewsText = _currentNewsData.title;
            this.currentNewsColor = _currentNewsData.themeColor;
        }
        else
        {
            this.sourceNewsList = _titleNewsList;
        }
        dispatchEvent(new Event(NewsSourceData.SET_CURRENT_TEXT))
    }
    private function setInfoText():void
    {
        _currentNewsData = _infoNewsList[0];
        this.currentNewsText = _currentNewsData.title;
        this.currentNewsColor = _currentNewsData.themeColor;
        dispatchEvent(new Event(NewsSourceData.SET_CURRENT_TEXT))
    }

    public function changeTextField():void
    {
        if (_sourceTextFieldBitmapData)
        {
            _sourceTextFieldBitmapData.dispose();
        }
        _sourceTextFieldBitmapData = new BitmapData(_bdW, _bdH, false, 0x000000);
        _textFieldData.setText(_currentNewsText);
        _textFieldWidthCount = BasicData.TEXT_DISPLAY_OFFSET_X;
    }

    public function set currentIndex(value:int):void
    {
        _setTextCount++;
        if(_setTextCount % 5 == 0)
        {
            setInfoText();
            _setTextCount = 0;
        }
        else
        {
            if (_sourceNewsList.length <= value)
            {
                _currentIndex = 0;
            }
            else
            {
                _currentIndex = value;
            }
            setCurrentText();
        }
    }

    public function get currentIndex():int
    {
        return _currentIndex;
    }

    public function get currentNewsColor():int
    {
        return _currentNewsColor;
    }

    public function set currentNewsColor(value:int):void
    {
        _currentNewsColor = value;
    }

    public function get currentNewsData():NewsData
    {
        return _currentNewsData;
    }

    public function get isTitleTextFinished():Boolean
    {
        return _isTitleTextFinished;
    }

    public function set isTitleTextFinished(value:Boolean):void
    {
        _isTitleTextFinished = value;
    }
}
}
