/**
 * Created by 393 on 2014/05/27.
 */
package model
{
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.MovieClip;
import flash.display.Sprite;
import flash.geom.Rectangle;
import flash.text.GridFitType;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.utils.Dictionary;

public class TextFieldData extends MovieClip
{
    private var _tfList:Vector.<TextField>;
    private var _bg:Bitmap;
    private var _icon:Bitmap = new Bitmap();
    private var _tfLength:int = 35;
    private var _newsSourceData:NewsSourceData;
    private var _container:Sprite;
    private var _categoryIconData:Dictionary = new Dictionary();

    public function TextFieldData(newsSourceData)
    {
        super();
        _newsSourceData = newsSourceData;
        init();
        initIcon();
    }

    private function initIcon():void
    {
        _categoryIconData["エンターテインメント"] = new CategoryIcon0();
        _categoryIconData["スポーツ"] = new CategoryIcon1();
        _categoryIconData["コンピュータ"] = new CategoryIcon2();
        _categoryIconData["サイエンス"] = new CategoryIcon3();
        _categoryIconData["経済"] = new CategoryIcon4();
        _categoryIconData["国内"] = new CategoryIcon5();
        _categoryIconData["海外"] = new CategoryIcon6();
        _categoryIconData["地域"] = new CategoryIcon7();
        _categoryIconData["タイトル"] = new TitleIcon();
        _categoryIconData["インフォメーション"] = new CategoryIconInfo();
    }

    private function init():void
    {
        _bg = new Bitmap();
        _icon = new Bitmap();
        _container = new Sprite();
        addChild(_bg);
        addChild(_icon);
        addChild(_container);
        _tfList = new Vector.<TextField>();
        for (var i:int = 0; i < _tfLength; i++)
        {
            var tfContainer:MovieClip = new TfContainer();
            addChild(tfContainer);
            var tf:TextField = tfContainer.tf;
            _container.addChild(tf);
            tf.textColor = 0xFF0000;
            tf.border = false;
            tf.background = false;
            tf.embedFonts = true;
            tf.autoSize = TextFieldAutoSize.LEFT;
            tf.gridFitType = GridFitType.SUBPIXEL;
            _tfList.push(tf);
        }
    }

    public function setText(text:String):void
    {
        resetTextField();
        setIcon();
        var textList:Array = text.split("");
        var l:int = textList.length;
        var nextX:int = _icon.width;
        var space:int = 0;
        for (var i:int = 0; i < l; i++)
        {
            _tfList[i].textColor = checkText(textList[i]);
            _tfList[i].text = textList[i];
            var rect0:Rectangle = getTextRect(_tfList[i]);
            nextX -= rect0.x;
            _tfList[i].x = nextX;
            var offsetY:int = (_tfList[i].height - rect0.y - rect0.height) - 12;
            if (offsetY >= 0 || _tfList[i].text == "「") offsetY = -4;
            _tfList[i].y = offsetY;
            if (rect0.width == 0) space = 4;
            else space = 1;
            nextX += (rect0.width + rect0.x + space);
        }
        setBg();
    }

    private function setIcon():void
    {
        _icon.bitmapData = _categoryIconData[_newsSourceData.currentNewsData.pickupCategory];
    }

    private function checkText(text:String):int
    {
        for (var i:int = 0, l:int = BasicData.KEYWORD_LIST.length; i < l; i++)
        {
            if (text == BasicData.KEYWORD_LIST[i])
            {
                return BasicData.TEXT_FORMAT_KEYWORD_COLOR;
            }
        }
        return BasicData.TEXT_FORMAT_COLOR;
    }

    private function getTextRect(textField:TextField):Rectangle
    {
        var bmd:BitmapData = new BitmapData(textField.width, textField.height, true, 0);
        bmd.draw(textField);
        return bmd.getColorBoundsRect(0xFF00000, 0, false);
    }

    private function resetTextField():void
    {
        for (var i:int = 0; i < _tfLength; i++)
        {
            _tfList[i].text = "";
            _tfList[i].x = 0;
            _tfList[i].y = 0;
        }
    }

    private function setBg():void
    {
        _bg.bitmapData = new BitmapData(this.width, this.height - 3, false, 0);
    }
}
}
