/**
 * Created by 393 on 2014/05/27.
 */
package view_controller
{
import a24.tween.Tween24;

import away3d.containers.ObjectContainer3D;
import away3d.core.base.Geometry;
import away3d.primitives.CubeGeometry;

import model.BasicData;
import model.NewsSourceData;

public class CubeContainer extends ObjectContainer3D
{
    private var _bdW:int = BasicData.TEXT_DISPLAY_WIDTH;
    private var _bdH:int = BasicData.TEXT_DISPLAY_HEIGHT;
    private var _cubeSize:int = BasicData.CUBE_SIZE;
    private var _cubeList:Vector.<Vector.<CustomCubeMeshContainer>> = new Vector.<Vector.<CustomCubeMeshContainer>>();
    private var _cubeListSingle:Vector.<CustomCubeMeshContainer> = new Vector.<CustomCubeMeshContainer>();
    private var _container:ObjectContainer3D;
    private var _newsSourceData:NewsSourceData;

    public function CubeContainer(newsSourceData:NewsSourceData)
    {
        super();
        _newsSourceData = newsSourceData;
        init();
    }

    private function init():void
    {
        _container = new ObjectContainer3D();
        this.addChild(_container);
        initCubeList();
    }

    private function initCubeList():void
    {
        var cube:Geometry = new CubeGeometry(_cubeSize, _cubeSize, _cubeSize);
        var count:int;
        var singleCount:int = 0;
        for (var i:int = 0; i < _bdH; i++)
        {
            _cubeList[i] = new Vector.<CustomCubeMeshContainer>();

            for (var j:int = 0; j < _bdW; j++)
            {
                var cubeMesh:CustomCubeMesh = new CustomCubeMesh(cube);
                count = j * (_bdH - i);
                var cubeMeshContainer:CustomCubeMeshContainer = new CustomCubeMeshContainer(cubeMesh, count);
                _cubeList[i][j] = cubeMeshContainer;
                _cubeList[i][j].x = -500;
                _container.addChild(cubeMeshContainer);
                _cubeListSingle[singleCount] = cubeMeshContainer;
                singleCount++;
            }
        }
    }

    public function get cubeList():Vector.<Vector.<CustomCubeMeshContainer>>
    {
        return _cubeList;
    }

    public function beatEffect():void
    {
        var i:int, j:int;
        for (i = 0; i < _bdH; i++)
        {
            for (j = 0; j < _bdW; j++)
            {
                _cubeList[i][j].mesh.beatEffect();
            }
        }
    }

    public function rhythmEffect():void
    {
        this.z = -8;
        Tween24.tween(this,0.3,Tween24.ease.SineOut).z(0).play();
    }

    public function changeAllColor(color:int, delay:Number = 0.002):void
    {
        changeColor(color, delay);
    }

    private function changeColor(color:int, delay:Number = 0.002):void
    {
        var i:int, j:int;
        for (i = 0; i < _bdH; i++)
        {
            for (j = 0; j < _bdW; j++)
            {
                Tween24.func(
                        function(cube:CustomCubeMeshContainer):void
                        {
                            if (color != 0) cube.changeColor(0, color)
                            else cube.changeBlackColor()
                        },_cubeList[i][j]
                ).delay(_cubeList[i][j].index * delay).play()
            }
        }
    }

    public function get cubeListSingle():Vector.<CustomCubeMeshContainer>
    {
        return _cubeListSingle;
    }
}
}
