/**
 * Created by 393 on 2014/06/02.
 */
package view_controller
{
import a24.tween.Tween24;

import away3d.containers.ObjectContainer3D;

import flash.geom.Vector3D;

import model.MaterialData;

public class CustomCubeMeshContainer extends ObjectContainer3D
{
    private var _defaultPosition:Vector3D = new Vector3D();
    private var _defaultPositionNoSpace:Vector3D = new Vector3D();
    private var _randomPosition:Vector3D = new Vector3D();
    private var _wavePosition:Vector3D = new Vector3D();
    private var _spherePosition:Vector3D = new Vector3D();
    private var _spherePositionNoSpace:Vector3D = new Vector3D();
    private var _crossPosition:Vector3D = new Vector3D();
    private var _crossPositionNoSpace:Vector3D = new Vector3D();
    private var _capLessBoxPosition:Vector3D = new Vector3D();
    private var _capLessBoxPositionNoSpace:Vector3D = new Vector3D();
    private var _boxPosition:Vector3D = new Vector3D();
    private var _boxPositionNoSpace:Vector3D = new Vector3D();
    private var _pyramidPosition:Vector3D = new Vector3D();
    private var _pyramidPositionNoScale:Vector3D = new Vector3D();
    private var _pipePosition:Vector3D = new Vector3D();
    private var _pipePositionNoSpace:Vector3D = new Vector3D();
    private var _gainOffset:int = 20;
    private var _mesh:CustomCubeMesh;
    private var _index:int;
    private var _meshContainer:ObjectContainer3D;

    public function CustomCubeMeshContainer(mesh:CustomCubeMesh, index:int)
    {
        super();

        _index = index;
        _mesh = mesh;
        _mesh.material = MaterialData.MATERIAL_BLACK.material;
        _meshContainer = new ObjectContainer3D();
        addChild(_meshContainer);
        _meshContainer.addChild(mesh);
    }


    public function changeYellowColor(soundGain:Number):void
    {
        _mesh.visible = true;
        _mesh.material = MaterialData.MATERIAL_YELLOW.material;
        _mesh.z = soundGain * -_gainOffset;
    }

    public function changeKeywordColor():void
    {
        _mesh.visible = true;
        _mesh.material = MaterialData.MATERIAL_YELLOW.material;
        _mesh.z = 0;
    }

    public function changeColor(soundGain:Number, colorIndex:int = 0):void
    {
        _mesh.visible = true;
        _mesh.material = MaterialData.getMaterialDataByThemeColor(colorIndex).material;
        _mesh.z = soundGain * -_gainOffset;
    }

    public function changeBlackColor():void
    {
        _mesh.visible = true;
        _mesh.material = MaterialData.MATERIAL_BLACK.material;
        _mesh.z = 0;
    }

    public function setDefaultPosition(isNoSpace:Boolean = false,isNoDelay:Boolean = false):void
    {
        if (isNoSpace) setPosition(_defaultPositionNoSpace,isNoDelay);
        else setPosition(_defaultPosition,isNoDelay);
    }

    public function setSpherePosition(isNoSpace:Boolean = false,isNoDelay:Boolean = false):void
    {
        if (isNoSpace) setPosition(_spherePositionNoSpace,isNoDelay);
        else setPosition(_spherePosition,isNoDelay);
    }

    public function setCrossPosition(isNoSpace:Boolean = false,isNoDelay:Boolean = false):void
    {
        if (isNoSpace) setPosition(_crossPositionNoSpace,isNoDelay);
        else setPosition(_crossPosition,isNoDelay);
    }

    public function setCapLessBoxPosition(isNoSpace:Boolean = false,isNoDelay:Boolean = false):void
    {
        if (isNoSpace) setPosition(_capLessBoxPositionNoSpace,isNoDelay);
        else setPosition(_capLessBoxPosition,isNoDelay);
    }

    public function setBoxPosition(isNoSpace:Boolean = false,isNoDelay:Boolean = false):void
    {
        if (isNoSpace) setPosition(_boxPositionNoSpace,isNoDelay);
        else setPosition(_boxPosition,isNoDelay);
    }

    public function setPipePosition(isNoSpace:Boolean = false,isNoDelay:Boolean = false):void
    {
        if (isNoSpace) setPosition(_pipePositionNoSpace,isNoDelay);
        else setPosition(_pipePosition,isNoDelay);
    }

    public function setRandomPosition(isNoDelay:Boolean = false):void
    {
        setPosition(_randomPosition,isNoDelay);
    }

    public function setPyramidPosition(isNoSpace:Boolean = false,isNoDelay:Boolean = false):void
    {
        if (isNoSpace) setPosition(_pyramidPositionNoScale,isNoDelay);
        else setPosition(_pyramidPosition,isNoDelay);
    }


    private function setPosition(position:Vector3D,isNoDelay:Boolean = false):void
    {
        var delay:Number = 0.0025;
        var time:Number = 0.5;
        if(isNoDelay) delay = 0;

        Tween24.tween(this,time,Tween24.ease.QuadOut).xyz(position.x,position.y,position.z).delay(_index * delay).play();
    }

    public function setWave():void
    {
        var time1:Number = 0.3;
        Tween24.serial(
                Tween24.prop(this).xyz(_wavePosition.x,_wavePosition.y,_wavePosition.z)
                ,Tween24.tween(this,time1,Tween24.ease.QuadOut).xyz(_defaultPosition.x,_defaultPosition.y,_defaultPosition.z)
        ).play();

    }

    public function get mesh():CustomCubeMesh
    {
        return _mesh;
    }

    public function get index():int
    {
        return _index;
    }

    public function set defaultPosition(value:Vector3D):void
    {
        _defaultPosition = value;
    }

    public function set randomPosition(value:Vector3D):void
    {
        _randomPosition = value;
    }

    public function set spherePosition(value:Vector3D):void
    {
        _spherePosition = value;
    }

    public function set capLessBoxPosition(value:Vector3D):void
    {
        _capLessBoxPosition = value;
    }

    public function set pipePosition(value:Vector3D):void
    {
        _pipePosition = value;
    }

    public function set boxPosition(value:Vector3D):void
    {
        _boxPosition = value;
    }


    public function set wavePosition(value:Vector3D):void
    {
        _wavePosition = value;
    }

    public function get defaultPosition():Vector3D
    {
        return _defaultPosition;
    }

    public function set boxPositionNoSpace(value:Vector3D):void
    {
        _boxPositionNoSpace = value;
    }

    public function set capLessBoxPositionNoSpace(value:Vector3D):void
    {
        _capLessBoxPositionNoSpace = value;
    }

    public function set defaultPositionNoSpace(value:Vector3D):void
    {
        _defaultPositionNoSpace = value;
    }

    public function set crossPosition(value:Vector3D):void
    {
        _crossPosition = value;
    }

    public function set crossPositionNoSpace(value:Vector3D):void
    {
        _crossPositionNoSpace = value;
    }

    public function set pyramidPosition(value:Vector3D):void
    {
        _pyramidPosition = value;
    }

    public function set pyramidPositionNoScale(value:Vector3D):void
    {
        _pyramidPositionNoScale = value;
    }

    public function set spherePositionNoSpace(value:Vector3D):void
    {
        _spherePositionNoSpace = value;
    }

    public function set pipePositionNoSpace(value:Vector3D):void
    {
        _pipePositionNoSpace = value;
    }
}
}
