/**
 * Created by 393 on 2014/05/21.
 */
package view_controller
{
import a24.tween.Tween24;

import flash.display.LoaderInfo;
import flash.display.MovieClip;
import flash.display.Sprite;
import flash.events.Event;
import flash.events.MouseEvent;
import flash.net.URLRequest;
import flash.net.navigateToURL;

import model.NewsSourceData;
import model.SoundData;

public class Main2DViewController extends ViewController
{
    private var _cover:MovieClip;
    private var _soundOffButotn:SoundOffButton;
    private var _yorupaneButton:YoruPaneButton;
    private var _newsSourceData:NewsSourceData;
    private var _soundData:SoundData;
    private var _playPauseButton:PlayPauseButton;
    private var _coverBg:MovieClip;
    private var _soundStartButton:MovieClip;

    public function Main2DViewController(newsSourceData:NewsSourceData, soundData:SoundData)
    {
        super();
        _newsSourceData = newsSourceData;
        _soundData = soundData;
        init();
    }

    private function init():void
    {
        _soundData.addEventListener(SoundData.BEAT_RHYTHM, beatRythmHandler);

        view = new Sprite();

        _soundOffButotn = new SoundOffButton();
        _soundOffButotn.buttonMode = true;
        view.addChild(_soundOffButotn);
        _soundOffButotn.visible = false;
        _soundOffButotn.x = 350 - 5 - _soundOffButotn.width;
        _soundOffButotn.y = 240 - 5 - _soundOffButotn.height;


        _playPauseButton = new PlayPauseButton();
        view.addChild(_playPauseButton);
        _playPauseButton.buttonMode = true;
        _playPauseButton.visible = false;
        _playPauseButton.x = _soundOffButotn.x - _playPauseButton.width - 5;
        _playPauseButton.y = 240 - 5 - _playPauseButton.height;

        _yorupaneButton = new YoruPaneButton();
        _yorupaneButton.buttonMode = true;
        _yorupaneButton.x = 350 - 60 - 5;
        _yorupaneButton.y = 5;

        view.addEventListener(Event.ADDED_TO_STAGE, addToStageHandler);

    }

    private function addToStageHandler(event:Event):void
    {
        view.removeEventListener(Event.ADDED_TO_STAGE, addToStageHandler);
        initClickTag();

        view.stage.addChild(_yorupaneButton);
    }

    private function beatRythmHandler(event:Event):void
    {
        if (_soundStartButton)
        {
            _soundStartButton.soundOnTextContainer.icon.gotoAndPlay("beat_start");
        }
    }

    private function initClickTag():void
    {
        var paramList:Object = LoaderInfo(view.root.loaderInfo).parameters;
        _yorupaneButton.addEventListener(MouseEvent.CLICK, openURL(paramList["clickTAG"], paramList["targetTAG"]));
    }

    private function openURL(clickTag:String, targetTag:String):Function
    {
        return function (evtObj:MouseEvent):void
        {
            if ((clickTag.substr(0, 5) == "http:") || (clickTag.substr(0, 6) == "https:"))
            {
                navigateToURL(new URLRequest(clickTag), targetTag);
            }
        }
    }

    private function cover_clickHandler(event:MouseEvent):void
    {
        _cover.removeEventListener(MouseEvent.CLICK, cover_clickHandler);
        Tween24.tween(_cover,.5).alpha(0).onComplete(soundStart).play();
    }

    private function soundButotn_clickHandler(event:MouseEvent):void
    {
        if (_soundOffButotn.currentFrameLabel == "off")
        {
            _soundOffButotn.gotoAndStop("on");
            _soundData.masterVolume = 1;
        }
        else
        {
            _soundOffButotn.gotoAndStop("off");
            _soundData.masterVolume = 0;
        }
    }


    private function playPauseButotn_clickHandler(event:MouseEvent):void
    {
        if (_playPauseButton.currentFrameLabel == "pause")
        {
            _playPauseButton.gotoAndStop("play");
            _soundData.isDriverPlay = false;
        }
        else
        {
            _playPauseButton.gotoAndStop("pause");
            _soundData.isDriverPlay = true;
        }
    }

    public function renderReady():void
    {
        if (MovieClip(view.root).bg != null)
        {
            _soundStartButton = MovieClip(view.root).bg;
            _soundStartButton.buttonMode = true;
            _soundStartButton.addEventListener(MouseEvent.CLICK, bg_clickHandler);
            _soundStartButton.addEventListener(MouseEvent.ROLL_OVER, bg_overHandler);
            _soundStartButton.addEventListener(MouseEvent.ROLL_OUT, bg_outHandler);

            Tween24.tween(_soundStartButton.blackArea,0.5).alpha(0.5).play();
        }
        else
        {
            _cover = new Cover();
            _cover.buttonMode = false;
            view.addChild(_cover);
            _cover.alpha = 0.5;
            _coverBg = _cover.coverBg;
            Tween24.tween(_coverBg,.3).alpha(0.3).play();
            _cover.addEventListener(MouseEvent.CLICK, cover_clickHandler);
        }
    }

    private function bg_outHandler(event:MouseEvent):void
    {
        _soundStartButton.soundOnTextContainer.gotoAndStop("out");
        _soundStartButton.blackArea.alpha = 0;
    }

    private function bg_overHandler(event:MouseEvent):void
    {
        _soundStartButton.soundOnTextContainer.gotoAndStop("over");
        _soundStartButton.blackArea.alpha = .5;
    }

    private function bg_clickHandler(event:MouseEvent):void
    {
        _soundStartButton.removeEventListener(MouseEvent.CLICK, cover_clickHandler);
        _soundStartButton.removeEventListener(MouseEvent.ROLL_OVER, bg_overHandler);
        _soundStartButton.removeEventListener(MouseEvent.ROLL_OUT, bg_outHandler);

        Tween24.tween(_soundStartButton,.5).alpha(0).onComplete(soundStart).play();
    }

    private function soundStart():void
    {
        if(_soundStartButton) _soundStartButton.visible = false;
        if(_cover) _cover.visible = false;

        _soundOffButotn.visible = true;
        _soundOffButotn.addEventListener(MouseEvent.CLICK, soundButotn_clickHandler);

        _playPauseButton.visible = true;
        _playPauseButton.addEventListener(MouseEvent.CLICK, playPauseButotn_clickHandler);
        _soundData.masterVolume = 1;
        _soundData.isTitleAnimeComplete = true;
    }
}
}
